
(require-extension regex)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Regular Expressions (uses subset of Gauche which is an opaque API)

(define string->regexp regexp)

;;regexp?

(define (rxmatch pat str)
  (let ((res (string-search-positions pat str)))
    (and res
         (cons str res))))

(define (rxmatch-num-matches m)
  (if (pair? m) (length (cdr m)) 0))

(define (rxmatch-start m . o)
  (car (if (pair? o) (list-ref (cdr m) (car o)) (cadr m))))

(define (rxmatch-end m . o)
  (cadr (if (pair? o) (list-ref (cdr m) (car o)) (cadr m))))

(define (rxmatch-substring m . o)
  (let ((x (if (pair? o) (list-ref (cdr m) (car o)) (cadr m))))
    (substring (car m) (car x) (cadr x))))

(define (rxmatch-before m)
  (substring (car m) 0 (caadr m)))

(define (rxmatch-after m)
  (substring (car m) (cadadr m) (string-length (car m))))

