
(require-extension (srfi 10000))

;; See http://groups-beta.google.com/group/comp.lang.scheme/browse_frm/thread/38a82d953cf62703/2c5e60798f04e2f8?q=lord+find&rnum=1#2c5e60798f04e2f8

;; Compiling this in Chicken produces an executable almost as fast as
;; find(1).  I suspect the reason Scheme was perceived as slow for this
;; task is simply because people weren't aware that find(1) uses a lot
;; of domain-specific optimizations such as checking hard-link counts.
;; The (common file) module implements these optimizations.

(common-module ()
  ((import-extension (common (io file)))
   (entry-point main))

(define (main args)
  (let ((dir (if (pair? (cdr args)) (cadr args) ".")))
    (directory-fold-tree dir (lambda (d f a) (print d "/" f)) #f)))

)
