
(require-extension (srfi 10000))

(common-module (common env)
  ((export
    getenv unsetenv current-host-name current-host-os
    current-implementation
    current-host-architecture current-user-id current-group-id
    user-id->name user-name->id user-home
    group-id->name group-name->id))

(define (current-implementation)
  'gambit)

(define getenv
  (let ((g getenv))
    (lambda (x) (g x #f))))

;;setenv

(define (unsetenv name)
  (setenv name))

(define (current-host-name)
  #f)

(define (current-host-os)
  #f)

(define (current-host-architecture)
  #f)

(define (current-user-id)
  (user-info-uid (user-info (getenv "USER"))))

(define (current-group-id)
  (user-info-gid (user-info (getenv "USER"))))

(define (user-id->name id)
  (user-info-name (user-info id)))

(define (user-name->id name)
  (user-info-uid (user-info name)))

(define (user-home . o)
  (let ((user (if (pair? o) (car o) (current-user-id))))
    (user-info-home (user-info user))))

(define (group-id->name id)
  (group-info-name (group-info id)))

(define (group-name->id name)
  (group-info-gid (group-info name)))

)
