
(require-extension (srfi 10000))

(common-module (common tcp)
  ((export tcp-connect tcp-serve))

(define (with-port-io p thunk)
  (with-input-from-port p
    (lambda () (with-output-to-port p thunk))))

(define (with-tcp-io host port thunk)
  (let ((p (open-tcp-client (list server-address: host
                                  port-number: port))))
    (with-port-io p thunk)))

(define (tcp-serve handler port . o) ; XXXX use threads
  (let ((server (open-tcp-server port)))
    (let lp ()
      (let ((p (read server)))
        (if (port? p)
          (begin
            (with-port-io p (lambda () (handler #f)))
            (lp)))))))

)
