
(define *load-path* '("." "~~/modules"))
(define *loaded-modules* '())

(define (find-in-path file ls)
  (let lp ((ls ls))
    (and (pair? ls)
         (let ((f (string-append (car ls) "/" file)))
           (if (file-exists? f)
             f
             (lp (cdr ls)))))))

(define (module->path sym)
  (let* ((s (symbol->string sym))
         (path
          (or (find-in-path (string-append s ".o1") *load-path*)
              (find-in-path (string-append s ".scm") *load-path*))))
    (and path (path-strip-extension path))))

(define (require x)
  (if (not (memq x *loaded-modules*))
    (let ((path (module->path x)))
      ;;(display "require: ") (write path) (newline)
      ;;somewhere the ~~/ is getting converted to ~/
      (load (if (and (eqv? #\~ (string-ref path 0))
                     (eqv? #\/ (string-ref path 1))
                     (not (or (file-exists? (string-append path ".o1"))
                              (file-exists? (string-append path ".scm")))))
              (string-append "~" path)
              path))
      (set! *loaded-modules* (cons x *loaded-modules*)))))

