
(define-module common.env
  (use file.util)
  (export-all))
(select-module common.env)

(define getenv sys-getenv)
(define setenv sys-setenv)
(define unsetenv sys-unsetenv)

(define (current-implementation)
  'gauche)

(define current-host-name sys-gethostname)

(define (current-host-os)
  (car (sys-uname)))
(define (current-host-architecture)
  (car (cddddr (sys-uname))))

(define current-user-id sys-getuid)
(define current-group-id sys-getgid)

(define user-id->name sys-uid->user-name)
(define user-name->id sys-user-name->uid)

(define group-id->name sys-gid->group-name)
(define group-name->id sys-group-name->gid)

(define user-home home-directory)

(provide "common/env")
