
(define-module common.string-cursor
  (export-all))
(select-module common.string-cursor)

(define (string-cursor? x) (string-pointer? x))

(define string-start-cursor make-string-pointer)

(define (string-end-cursor str) (make-string-pointer str -1))

(define (string-cursor-start? str c)
  (zero? (string-pointer-byte-index c)))

(define (string-cursor-end? str c)
  (eof-object? (string-pointer-ref c)))

(define (string-cursor-substring s c1 c2)
  (substring s (string-pointer-index c1) (string-pointer-index c2)))

(define (string-cursor-next str c)
  (let ((res (string-pointer-copy c)))
    (string-pointer-next! res)
    res))

(define (string-cursor-prev str c)
  (let ((res (string-pointer-copy c)))
    (string-pointer-prev! res)
    res))

(define (string-cursor-ref str c)
  (string-pointer-ref c))

;; add full grapheme support later

(define string-cursor-grapheme-next string-cursor-next)

(define string-cursor-grapheme-prev string-cursor-prev)

(define string-cursor-grapheme-ref string-cursor-ref)

(provide "common/string-cursor")

