
(define-module common.tcp
  (use gauche.net)
  (use gauche.selector)
  (export-all))
(select-module common.tcp)

(define (with-tcp-io host port thunk)
  (call-with-client-socket
     (make-client-socket 'inet host port)
   (lambda (in out)
     (with-input-from-port in
       (lambda () (with-output-to-port out thunk))))))

(define (tcp-serve handler port . o)
  (let ((selector (make <selector>))
        (server   (make-server-socket 'inet port :reuse-addr? #t)))
    (define (accept-handler sock flag)
      (let* ((client (socket-accept server))
             (input  (socket-input-port client :buffering :none))
             (output (socket-output-port client)))
        ;;(format #t "client from ~a\n" (socket-address client))
        (selector-add! selector input
          (lambda _
            (with-input-from-port input
              (lambda ()
                (with-output-to-port output
                  (lambda ()
                    (handler (sockaddr-name (socket-address client)))))))
            (socket-close client))
          '(r))))
    (selector-add! selector (socket-fd server) accept-handler '(r))
    (do () (#f) (selector-select selector))))

(provide "common/tcp")

