
(define-module (common env))

(export
 unsetenv current-host-name current-host-os
 current-implementation current-host-architecture
 current-user-id current-group-id
 user-id->name user-name->id user-home
 group-id->name group-name->id)

;;(define getenv getenv)

;;(define setenv setenv)

(define (unsetenv name) (sys:setenv name #f))

(define (current-implementation)
  'guile)

(define (current-host-name)
  (gethostname))

(define (current-host-os)
  (utsname:sysname (uname)))

(define (current-host-architecture)
  (utsname:machine (uname)))

(define (current-user-id)
  (passwd:uid (getpwnam (cuserid))))

(define (current-group-id)
  (passwd:gid (getpwnam (cuserid))))

(define (user-id->name uid)
  (passwd:name (getpwuid uid)))

(define (user-name->id name)
  (passwd:uid (getpwnam name)))

(define (user-home . o)
  (let ((x (if (pair? o) (car o) (cuserid))))
    (passwd:dir ((if (integer? x) getpwuid getpwnam) x))))

(define (group-id->name gid)
  (group:name (getgrgid gid)))

(define (group-name->id name)
  (group:gid (getgrnam name)))
