
(define-module (common tcp))

(export with-tcp-io tcp-serve)

(define (with-tcp-io host port thunk)
  (let ((s (socket PF_INET SOCK_STREAM 0)))
    (connect s AF_INET (car (hostent:addr-list (gethost host))) port)
    (let ((res
           (with-input-from-port s
             (lambda () (with-output-to-port s thunk)))))
      (close-port s)
      res)))

(define (tcp-serve handler port . o)
  (let ((s (socket PF_INET SOCK_STREAM 0)))
    (setsockopt s SOL_SOCKET SO_REUSEADDR 1)
    (bind s AF_INET INADDR_ANY port)
    (listen s 5)
    (while #t
      (let* ((client-connection (accept s))
             (client-details (cdr client-connection))
             (client (car client-connection)))
        (with-input-from-port client
          (lambda ()
            (with-output-to-port client
              (lambda ()
                (handler (gethostbyaddr (sockaddr:addr client-details)))
                (close client)))))))))
