
(import file-manipulation)

(module common/file
  (directory-files delete-file rename-file create-directory
   ;;create-symbolic-link read-symbolic-link
   directory-fold directory-fold-tree file-modification-time
   file-size file-directory? find-in-path
   ;;file-exists?
   )

(define delete-file file-delete!)

;;(define file-exists? file-exists?)

(define file-directory? file-is-directory?)

(define rename-file file-rename!)

(define create-directory make-directory!)

; (define create-symbolic-link #f)
; (define read-symbolic-link #f)

(define file-modification-time file-last-modified)

(define file-size file-length)

(define directory-files directory-list)

;;(define file-is-directory? file-is-directory?)

(define (directory-fold dir kons knil)
  (let lp ((ls (cddr (directory dir))) (acc knil))
    (if (null? ls)
      acc
      (lp (cdr ls) (kons (car ls) acc)))))

(define (directory-fold-tree dir kons knil)
  (let lp ((ls (directory-files dir))
           (d dir)
           (acc knil))
    (cond
      ((null? ls)
       acc)
      ((let ((d2 (string-append d "/" (car ls))))
         (and (file-directory? d2) d2))
       =>
       (lambda (d2)
         (lp (cdr ls)
             d
             (kons d (car ls)
                   (lp (directory-files d2) d2 acc)))))
      (else
       (lp (cdr ls) d (kons d (car ls) acc))))))

(define (find-in-path file ls . o)
  (let ((pred (if (pair? o) (car o) (lambda (f) #t))))
    (let lp ((ls ls))
      (and (pair? ls)
           (let* ((dir (car ls))
                  (len (string-length dir))
                  (path (if (eqv? #\/ (string-ref dir (- len 1)))
                          (string-append dir file)
                          (string-append dir "/" file))))
             (if (and (file-exists? path) (pred path))
               path
               (lp (cdr ls))))))))

)
