
(import string-io)

(module common/io
  (read-line pr nl flush-output with-string-io current-error-port)

(define flush-output flush-output-port)

(define (pr . args)
  (for-each display args))

(define nl #\newline)

(define (read-line . o)
  (let ((p (if (pair? o) (car o) (current-input-port))))
    (let lp ((res '()))
      (let ((c (read-char p)))
        (if (or (eof-object? c) (eqv? c #\newline))
          (list->string (reverse res))
          (lp (cons c res)))))))

(define (with-string-io str thunk)
  (with-output-to-string
    (lambda ()
      (with-input-from-string str thunk))))

(define current-error-port current-output-port)

)
