
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common combinators))
  (entry-point main))

(define (main args)

(test-begin "combinators")

(test-eq #t true)
(test-eq #t (always-true))
(test-eq #t (always-true #f))
(test-eq #t (always-true #f #f))
(test-eq #f false)
(test-eq #f (always-false))
(test-eq #f (always-false #f))
(test-eq #f (always-false #f #f))

(test-equal 'id (identity 'id))
(test-equal 'id (I 'id))
(test-equal 'ego ((constantly 'ego) 'id))

(test-eq #t ((conjoin) 1))
(test-eq #t ((conjoin always-true) 2))
(test-eq #f ((conjoin always-true always-false) 3))
(test-eq #f ((disjoin) 4))
(test-eq #t ((disjoin always-true) 5))
(test-eq #t ((disjoin always-true always-false) 6))

(test-eq #f ((complement always-true) #t))
(test-eq #t ((complement always-false) #f))

(test-eqv 23 ((compose (lambda (x) (+ x 3)) (lambda (x) (* x 10))) 2))

(test-equal '(1 2) ((flip list) 2 1))
(test-eqv 1 (K 1 2))

(test-eqv 2 (fix (lambda (x) (+ (* x x) (- (* 3 x)) 4)) 1 eqv?))

(test-assert (S complement identity always-false))

(test-eqv 16
          ((Y (lambda (ackermann)
                (lambda (a b)
                  (cond ((eq? a 1) (expt 2 b))
                        ((eq? b 1) (ackermann (- a 1) 2))
                        (else (ackermann (- a 1) (ackermann a (- b 1))))))))
           3 1))

(test-end "combinators")

))
