
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common env))
  (entry-point main))

(define (main args)

(test-begin "env")

(test-assert (integer? (current-user-id)))
(test-assert (integer? (current-group-id)))

(test-equal (current-user-id) (user-name->id (or (getenv "USER") (getenv "LOGIN"))))
(test-equal (user-id->name (current-user-id)) (or (getenv "USER") (getenv "LOGIN")))

(test-equal (user-home) (user-home (current-user-id)))
(test-equal (user-home) (getenv "HOME"))

(test-assert (not (getenv "IM_A_FOOL_IF_I_SET_THIS_BEFORE_TESTING")))
(test-assert (setenv "IM_A_FOOL_IF_I_SET_THIS_BEFORE_TESTING" "DUH"))
(test-equal "DUH" (getenv "IM_A_FOOL_IF_I_SET_THIS_BEFORE_TESTING"))
(test-assert (unsetenv "IM_A_FOOL_IF_I_SET_THIS_BEFORE_TESTING"))
(test-assert (not (getenv "IM_A_FOOL_IF_I_SET_THIS_BEFORE_TESTING")))

(test-end "env")

))
