
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common file))
  (entry-point main))

(define (main args)

(define (sort2 ls)
  (if (string<? (car ls) (cadr ls)) ls (list (cadr ls) (car ls))))

(test-begin "file")

(test-assert (create-directory "test-dir"))

(test-assert (file-directory? "test-dir"))

(test-assert (with-output-to-file "test-dir/a" (lambda () (write 'ok) #t)))

(test-assert (file-regular? "test-dir/a"))
(test-assert (file-readable? "test-dir/a"))
(test-assert (file-writable? "test-dir/a"))

(test-eqv 2 (file-size "test-dir/a"))

(test-assert (copy-file "test-dir/a" "test-dir/a.bak"))
(test-eqv 2 (file-size "test-dir/a.bak"))
(test-assert (delete-file "test-dir/a.bak"))

(let ((time1 (file-modification-time "test-dir/a")))

  (test-assert (with-output-to-file "test-dir/b" (lambda () (write 'ok) #t)))

  (let ((time2 (file-modification-time "test-dir/b" )))

    (test-assert (<= time1 time2))

    (test-assert (rename-file "test-dir/b" "test-dir/c"))

    (test-equal '("a" "c") (sort2 (directory-files "test-dir")))
    (test-equal '("a" "c") (sort2 (directory-fold "test-dir" cons '())))
    (test-equal "test-dir/a" (find-in-path "a" '("/no/such/place" "test-dir")))

    (test-assert (delete-file "test-dir/a"))
    (test-assert (delete-file "test-dir/c"))

    ))

(test-assert (create-directory* "test-dir/d/e"))
(test-assert (delete-file "test-dir/d/e"))
(test-assert (delete-file "test-dir/d"))

(test-assert (delete-file "test-dir"))

(test-end "file")

))
