
(require-extension (srfi 10000))

(common-module ()
 ((import-syntax (srfi testing))
  (import-extension (common string-cursor))
  (entry-point main))

(define (main args)

(test-begin "string-cursor")

(let ((s "abc"))

  (test-assert (string-cursor? (string-start-cursor s)))
  (test-assert (string-cursor? (string-end-cursor s)))
  (test-assert (string-cursor-start? s (string-start-cursor s)))
  (test-assert (string-cursor-end? s (string-end-cursor s)))

  (test-equal #\a (string-cursor-ref s (string-start-cursor s)))
  (test-equal #\b (string-cursor-ref s (string-cursor-next s (string-start-cursor s))))
  (test-equal #\c (string-cursor-ref s (string-cursor-prev s (string-end-cursor s))))

  (test-equal s (string-cursor-substring s (string-start-cursor s) (string-end-cursor s)))
  (test-equal "a" (string-cursor-substring s (string-start-cursor s) (string-cursor-next s (string-start-cursor s))))

  (test-equal #\a (string-cursor-grapheme-ref s (string-start-cursor s)))
  (test-equal #\b (string-cursor-grapheme-ref s (string-cursor-next s (string-start-cursor s))))
  (test-equal #\c (string-cursor-grapheme-ref s (string-cursor-prev s (string-end-cursor s))))

  )

(test-end "string-cursor")

))
